/****************************************************************************/
/* ZEPTOOS:zepto-info */
/*     This file is part of ZeptoOS: The Small Linux for Big Computers.
 *     See www.mcs.anl.gov/zeptoos for more information.
 */
/* ZEPTOOS:zepto-info */
/* */
/* ZEPTOOS:zepto-fillin */
/*     $Id: test2.c,v 1.4 2007/06/27 15:10:45 iskra Exp $
 *     ZeptoOS_Version: 1.2
 *     ZeptoOS_Heredity: FOSS_ORIG
 *     ZeptoOS_License: GPL
 */
/* ZEPTOOS:zepto-fillin */
/* */
/* ZEPTOOS:zepto-gpl */
/*      Copyright: Argonne National Laboratory, Department of Energy,
 *                 and UChicago Argonne, LLC.  2004, 2005, 2006, 2007
 *      ZeptoOS License: GPL
 * 
 *      This software is free.  See the file ZeptoOS/misc/license.GPL
 *      for complete details on your rights to copy, modify, and use this
 *      software.
 */
/* ZEPTOOS:zepto-gpl */
/****************************************************************************/

/* This test verifies that input "userbuf" operations work correctly.  */

#include <assert.h>
#include <stdio.h>
#include <stdlib.h>

#include "test.h"

#define BUF1 (1024*1024*10)
#define BUF2 (1024*1024*4-MAX)
#define MAX 4096

int main(void)
{
    char* buf;
    int size;
    int ret;

    fprintf(stderr, "Starting...\n");

    buf = malloc(BUF1 + MAX);
    assert(buf);

    for (size = BUF1; size < BUF1 + MAX; size++)
    {
	int i;

	for (i = 0; i < size; i++)
	    buf[i] = random();

	if ((ret = test_write(buf, size)) != size)
	{
	    fprintf(stderr, "test_write failed: %d!\n", ret);
	    return 1;
	}
    }

    free(buf);

    fprintf(stderr, "Finished first part...\n");

    buf = malloc(BUF2 + MAX);
    assert(buf);

    for (size = BUF2; size < BUF2 + MAX; size++)
    {
	int i;

	for (i = 0; i < size; i++)
	    buf[i] = random();

	if ((ret = test_write_noub(buf, size)) != size)
	{
	    fprintf(stderr, "test_write failed: %d!\n", ret);
	    return 1;
	}
    }

    free(buf);

    fprintf(stderr, "Finished second part...\n");

    return 0;
}
