/****************************************************************************/
/* ZEPTOOS:zepto-info */
/*     This file is part of ZeptoOS: The Small Linux for Big Computers.
 *     See www.mcs.anl.gov/zeptoos for more information.
 */
/* ZEPTOOS:zepto-info */
/* */
/* ZEPTOOS:zepto-fillin */
/*     $Id: unix_internal.h,v 1.5 2007/06/27 15:10:45 iskra Exp $
 *     ZeptoOS_Version: 1.2
 *     ZeptoOS_Heredity: FOSS_ORIG
 *     ZeptoOS_License: GPL
 */
/* ZEPTOOS:zepto-fillin */
/* */
/* ZEPTOOS:zepto-gpl */
/*      Copyright: Argonne National Laboratory, Department of Energy,
 *                 and UChicago Argonne, LLC.  2004, 2005, 2006, 2007
 *      ZeptoOS License: GPL
 * 
 *      This software is free.  See the file ZeptoOS/misc/license.GPL
 *      for complete details on your rights to copy, modify, and use this
 *      software.
 */
/* ZEPTOOS:zepto-gpl */
/****************************************************************************/

#ifndef UNIX_INTERNAL_H
#define UNIX_INTERNAL_H

/* Value for a closed file descriptor.  */
#define FD_UNUSED -1

/* Default values of fds 1 and 2, respectively.  */
#define FD_DEFAULT_STDOUT -2
#define FD_DEFAULT_STDERR -3

int unix__record_fd(int server_fd);
int unix__record_fd_at(int server_fd, int client_fd);
int unix__translate_client_fd(int client_fd);
void unix__clear_client_fd(int client_fd);
int unix__getcwd_fd(void);
void unix__setcwd_fd(int cwd_fd);
mode_t unix__getumask(void);
mode_t unix__setumask(mode_t mask);
void unix__cwd_mask_lock(void);
void unix__cwd_mask_unlock(void);

#endif
